

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Grid post-processing of Met.no data using SHyFT API &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Penman-Monteith Single Method Verification" href="../penman-monteith/penman-monteith-verification-single-method.html" />
    <link rel="prev" title="This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating" href="kalman_updating.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="gridpp_geopoints.html">Demonstration of SHyFT API implementation of Kalman Filtering on gridded data</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html">This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#2.-Create-Kalman-filter">2. Create Kalman filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#3.-Creates-start-states">3. Creates start states</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#4.-Update-filter">4. Update filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#5.-Plot-results">5. Plot results</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#6.-Test-to-see-how-choice-of-parameters-impact-filter">6. Test to see how choice of parameters impact filter</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Grid post-processing of Met.no data using SHyFT API</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:">This notebook gives an example of Met.no data post-processing to correct temperature forecasts based on comparison to observations. The following steps are described:</a></li>
<li class="toctree-l4"><a class="reference internal" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#2.-Create-synthetic-data-for-observation-time-series">2. Create synthetic data for observation time-series</a></li>
<li class="toctree-l4"><a class="reference internal" href="#3.-Create-synthetic-data-for-forecast-time-series">3. Create synthetic data for forecast time-series</a></li>
<li class="toctree-l4"><a class="reference internal" href="#4.-Calculate-correction-bias-between-observations-and-forecasts">4. Calculate correction bias between observations and forecasts</a></li>
<li class="toctree-l4"><a class="reference internal" href="#5.-Apply-bias-correction-to-forecast-time-series">5. Apply bias correction to forecast time-series</a></li>
<li class="toctree-l4"><a class="reference internal" href="#6.-Plot-the-results">6. Plot the results</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../penman-monteith/penman-monteith-verification-single-method.html">Penman-Monteith Single Method Verification</a></li>
<li class="toctree-l3"><a class="reference internal" href="../penman-monteith/penman-monteith-sensitivity.html">Penman-Monteith Sensitivity</a></li>
<li class="toctree-l3"><a class="reference internal" href="../radiation/polar_region_radiaiton.html">Checking calculation of Radiation at Polar Region</a></li>
<li class="toctree-l3"><a class="reference internal" href="../radiation/radiation-sensitivity-analysis.html">Sensitivity analysis of radiation routine</a></li>
<li class="toctree-l3"><a class="reference internal" href="../radiation/radiation_camelsdata.html">This notebook demonstarates the radiation algorithm on the camels data:</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Grid post-processing of Met.no data using SHyFT API</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/grid-pp/ordinary_kriging_precipitation.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Grid-post-processing-of-Met.no-data-using-SHyFT-API">
<h1>Grid post-processing of Met.no data using SHyFT API<a class="headerlink" href="#Grid-post-processing-of-Met.no-data-using-SHyFT-API" title="Permalink to this headline">¶</a></h1>
<div class="section" id="This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:">
<h2>This notebook gives an example of Met.no data post-processing to correct temperature forecasts based on comparison to observations. The following steps are described:<a class="headerlink" href="#This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:" title="Permalink to this headline">¶</a></h2>
<ol class="arabic simple">
<li><p><strong>Loading required python modules and setting path to SHyFT installation</strong></p></li>
<li><p><strong>Create synthetic data for observation time-series</strong></p></li>
<li><p><strong>Create synthetic data for forecast time-series</strong></p></li>
<li><p><strong>Calculate correction bias between observations and forecasts</strong></p></li>
<li><p><strong>Apply bias correction to forecast time-series</strong></p></li>
<li><p><strong>Plot the results</strong></p></li>
</ol>
</div>
<div class="section" id="1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">
<h2>1. Loading required python modules and setting path to SHyFT installation<a class="headerlink" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># First you should import the third-party python modules</span>
<span class="c1"># The first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">pylab</span> inline
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>

<span class="c1"># If you want to use your own local build of shyft, you can set the path or the environment PYTHONPATH</span>
<span class="c1"># import os, sys</span>
<span class="c1"># from os import path</span>
<span class="c1"># sys.path.insert(0, os.path.abspath(&quot;../../../shyft&quot;))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Populating the interactive namespace from numpy and matplotlib
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># To import shyft, it is enough to activate the conda environment where shyft is installed</span>

<span class="kn">from</span> <span class="nn">shyft.repository.default_state_repository</span> <span class="kn">import</span> <span class="n">DefaultStateRepository</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.configuration</span> <span class="kn">import</span> <span class="n">yaml_configs</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigSimulator</span>
<span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">api</span>

<span class="c1"># If you have problems here, it may be related to having your LD_LIBRARY_PATH</span>
<span class="c1"># pointing to the appropriate libboost_python libraries (.so files)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Now you can access the shyft api with tab completion and help, try this:</span>
<span class="c1"># help(api.GeoPoint) # remove the hashtag and run the cell to print the documentation of the api.GeoPoint class</span>
<span class="c1"># api. # remove the hashtag, set the pointer behind the dot and use tab completion to see the available attributes</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="2.-Create-synthetic-data-for-observation-time-series">
<h2>2. Create synthetic data for observation time-series<a class="headerlink" href="#2.-Create-synthetic-data-for-observation-time-series" title="Permalink to this headline">¶</a></h2>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create time-axis starting 01.01.2016, sampled every hour for 10 days long</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">Calendar</span><span class="p">()</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2016</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">ta</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">1</span><span class="p">),</span> <span class="mi">240</span><span class="p">)</span>

<span class="c1"># Create a set of geo-locations at observation points (sparse set covering the forecast grid)</span>
<span class="n">obs_locs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoPointVector</span><span class="p">()</span>
<span class="n">obs_locs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span>   <span class="mi">10</span><span class="p">))</span>
<span class="n">obs_locs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span><span class="mi">5100</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span>  <span class="mi">250</span><span class="p">))</span>
<span class="n">obs_locs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">5100</span><span class="p">,</span> <span class="mi">250</span><span class="p">))</span>
<span class="n">obs_locs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span><span class="mi">5100</span><span class="p">,</span> <span class="mi">5100</span><span class="p">,</span> <span class="mi">500</span><span class="p">))</span>

<span class="c1"># Create a set of time-series at observation points, having constant value</span>
<span class="n">obs_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoPointSourceVector</span><span class="p">()</span>
<span class="k">for</span> <span class="n">loc</span> <span class="ow">in</span> <span class="n">obs_locs</span><span class="p">:</span>
    <span class="n">obs_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPointSource</span><span class="p">(</span><span class="n">loc</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta</span><span class="p">,</span> <span class="n">fill_value</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span><span class="n">point_fx</span><span class="o">=</span><span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)))</span>

<span class="c1"># Create a set of geo-locations at forecast points (evenly spaced grid of 10 x 10 km)</span>
<span class="n">fc_locs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoPointVector</span><span class="p">()</span>
<span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
    <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
        <span class="n">fc_locs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span><span class="n">x</span><span class="o">*</span><span class="mi">1000</span><span class="p">,</span> <span class="n">y</span><span class="o">*</span><span class="mi">1000</span><span class="p">,</span> <span class="p">(</span><span class="n">x</span><span class="o">+</span><span class="n">y</span><span class="p">)</span><span class="o">*</span><span class="mi">50</span><span class="p">))</span>

<span class="c1"># Spread the set of observations to forecast locations by ordinary Kriging</span>
<span class="n">obs_grid</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">ordinary_kriging</span><span class="p">(</span><span class="n">obs_set</span><span class="p">,</span> <span class="n">fc_locs</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">OKParameter</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Define a function to calculate the deviation in percent</span>
<span class="k">def</span> <span class="nf">deviation</span><span class="p">(</span><span class="n">v1</span><span class="p">,</span> <span class="n">v2</span><span class="p">):</span>
    <span class="n">d</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">v1</span> <span class="o">-</span> <span class="n">v2</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">v1</span><span class="p">:</span>
        <span class="n">d</span> <span class="o">=</span> <span class="mi">100</span> <span class="o">*</span> <span class="nb">abs</span><span class="p">(</span><span class="n">d</span> <span class="o">/</span> <span class="n">v1</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">d</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="3.-Create-synthetic-data-for-forecast-time-series">
<h2>3. Create synthetic data for forecast time-series<a class="headerlink" href="#3.-Create-synthetic-data-for-forecast-time-series" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create an empty forecast grid</span>
<span class="n">fc_grid</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">PrecipitationSourceVector</span><span class="p">()</span>

<span class="c1"># Create a synthetic bias time-serie</span>
<span class="n">bias_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta</span><span class="p">,</span> <span class="n">fill_value</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span><span class="n">point_fx</span><span class="o">=</span><span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>

<span class="c1"># Create forecast time-series by adding the synthetic bias to the observation time-series</span>
<span class="k">for</span> <span class="n">obs</span> <span class="ow">in</span> <span class="n">obs_grid</span><span class="p">:</span>
    <span class="n">fc_grid</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">PrecipitationSource</span><span class="p">(</span><span class="n">obs</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span> <span class="n">obs</span><span class="o">.</span><span class="n">ts</span> <span class="o">+</span> <span class="n">bias_ts</span><span class="p">))</span>

<span class="c1"># Create a forecast set to observation locations by IDW transform</span>
<span class="n">fc_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">idw_precipitation</span><span class="p">(</span><span class="n">fc_grid</span><span class="p">,</span> <span class="n">obs_locs</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">IDWPrecipitationParameter</span><span class="p">())</span>

<span class="c1"># Check deviation of grid mapping vs observation locations</span>
<span class="n">d</span> <span class="o">=</span> <span class="n">deviation</span><span class="p">(</span><span class="n">fc_grid</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">),</span> <span class="n">fc_set</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;The deviation of grid mapping is </span><span class="si">{0:.2f}</span><span class="s1">%&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">d</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
The deviation of grid mapping is 0.01%
</pre></div></div>
</div>
</div>
<div class="section" id="4.-Calculate-correction-bias-between-observations-and-forecasts">
<h2>4. Calculate correction bias between observations and forecasts<a class="headerlink" href="#4.-Calculate-correction-bias-between-observations-and-forecasts" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create an empty bias set</span>
<span class="n">bias_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoPointSourceVector</span><span class="p">()</span>

<span class="c1"># Calculate the bias as a correction factor between observation and forecast timeseries at observation locations</span>
<span class="k">for</span> <span class="p">(</span><span class="n">obs</span><span class="p">,</span> <span class="n">fc</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">obs_set</span><span class="p">,</span> <span class="n">fc_set</span><span class="p">):</span>
    <span class="n">bias_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPointSource</span><span class="p">(</span><span class="n">obs</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span> <span class="n">obs</span><span class="o">.</span><span class="n">ts</span> <span class="o">/</span> <span class="n">fc</span><span class="o">.</span><span class="n">ts</span><span class="p">))</span>

<span class="c1"># Spread the bias from observation locations to forecast locations by ordinary kriging</span>
<span class="n">bias_grid</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">ordinary_kriging</span><span class="p">(</span><span class="n">bias_set</span><span class="p">,</span> <span class="n">fc_locs</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">OKParameter</span><span class="p">())</span>

<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;The correction factor at the first forecast location is </span><span class="si">{0:.3f}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">bias_grid</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">)))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
The correction factor at the first forecast location is 0.909
</pre></div></div>
</div>
</div>
<div class="section" id="5.-Apply-bias-correction-to-forecast-time-series">
<h2>5. Apply bias correction to forecast time-series<a class="headerlink" href="#5.-Apply-bias-correction-to-forecast-time-series" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Apply bias correction to forecast time-series at forecast locations</span>
<span class="k">for</span> <span class="p">(</span><span class="n">fc</span><span class="p">,</span> <span class="n">bias</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">fc_grid</span><span class="p">,</span> <span class="n">bias_grid</span><span class="p">):</span>
    <span class="n">fc</span><span class="o">.</span><span class="n">ts</span> <span class="o">=</span> <span class="n">fc</span><span class="o">.</span><span class="n">ts</span> <span class="o">*</span> <span class="n">bias</span><span class="o">.</span><span class="n">ts</span>

<span class="c1"># Transform corrected forecasts to observation locations by IDW transform</span>
<span class="n">fc_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">idw_precipitation</span><span class="p">(</span><span class="n">fc_grid</span><span class="p">,</span> <span class="n">obs_locs</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">IDWPrecipitationParameter</span><span class="p">())</span>

<span class="c1"># Check deviation of corrected forecast vs observation</span>
<span class="n">d</span> <span class="o">=</span> <span class="n">deviation</span><span class="p">(</span><span class="n">obs_set</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">),</span> <span class="n">fc_set</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;The deviation of corrected forecast is </span><span class="si">{0:.2f}</span><span class="s1">%&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">d</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
The deviation of corrected forecast is 0.01%
</pre></div></div>
</div>
</div>
<div class="section" id="6.-Plot-the-results">
<h2>6. Plot the results<a class="headerlink" href="#6.-Plot-the-results" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Make a plot of time-series</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">20</span><span class="p">,</span> <span class="mi">10</span><span class="p">))</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">bias_set</span><span class="p">)):</span>
    <span class="n">timestamps</span> <span class="o">=</span> <span class="p">[</span><span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">start</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">time_axis</span><span class="p">]</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; Observation&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">fc_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; Forecast&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">bias_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; Bias&#39;</span><span class="p">)</span>
<span class="n">fig</span><span class="o">.</span><span class="n">autofmt_xdate</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s1">&#39;Precipitation&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;Precipitation&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;Precipitation&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_ordinary_kriging_precipitation_15_1.png" src="../../_images/notebooks_grid-pp_ordinary_kriging_precipitation_15_1.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Make a scatter plot of grid forecasts at ts.value(0)</span>
<span class="n">x</span> <span class="o">=</span> <span class="p">[</span><span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">x</span> <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">fc_grid</span><span class="p">]</span>
<span class="n">y</span> <span class="o">=</span> <span class="p">[</span><span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">y</span> <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">fc_grid</span><span class="p">]</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">5</span><span class="p">))</span>
<span class="n">vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">fc</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span> <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">fc_grid</span><span class="p">])</span>
<span class="n">v120</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">vals</span><span class="p">)</span> <span class="o">*</span> <span class="mf">1.2</span> <span class="c1"># Set color scale to 120% of max value</span>
<span class="n">plot</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">vals</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;s&#39;</span><span class="p">,</span> <span class="n">vmin</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">vmax</span><span class="o">=</span><span class="n">v120</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">500</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span><span class="n">plot</span><span class="p">)</span><span class="o">.</span><span class="n">set_label</span><span class="p">(</span><span class="s1">&#39;Forecast&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_ordinary_kriging_precipitation_16_0.png" src="../../_images/notebooks_grid-pp_ordinary_kriging_precipitation_16_0.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">fig</span><span class="p">,</span> <span class="p">(</span><span class="n">ax1</span><span class="p">,</span> <span class="n">ax2</span><span class="p">)</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="n">sharey</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">obs</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span> <span class="k">for</span> <span class="n">obs</span> <span class="ow">in</span> <span class="n">obs_grid</span><span class="p">])</span>
<span class="n">ax1</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">vals</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;s&#39;</span><span class="p">,</span> <span class="n">vmin</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">vmax</span><span class="o">=</span><span class="n">v120</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">500</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="n">vals</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">bias</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span> <span class="k">for</span> <span class="n">bias</span> <span class="ow">in</span> <span class="n">bias_grid</span><span class="p">])</span>
<span class="n">ax2</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">vals</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;s&#39;</span><span class="p">,</span> <span class="n">vmin</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">vmax</span><span class="o">=</span><span class="n">v120</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">500</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="c1">#plt.colorbar(plot).set_label(&#39;Observations vs. bias&#39;)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.collections.PathCollection at 0x7fab8438d198&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_ordinary_kriging_precipitation_17_1.png" src="../../_images/notebooks_grid-pp_ordinary_kriging_precipitation_17_1.png" />
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../penman-monteith/penman-monteith-verification-single-method.html" class="btn btn-neutral float-right" title="Penman-Monteith Single Method Verification" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="kalman_updating.html" class="btn btn-neutral float-left" title="This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>